/*
  This dummy sorts the points in ascending lexicographic order
*/

#include <algorithm> // std::sort
#include <iterator> // std::iterator_traits

namespace lexicographic_sort {

  template<typename I>
  I solve(I first, I past) {
    using P = typename std::iterator_traits<I>::value_type;
    std::sort(first, past,
      [](P const& a, P const& b) -> bool {
        return (a.x < b.x) or (a.x == b.x and a.y < b.y);
      });
    return past;
  }
}