/*
  This dummy sorts the points according to their x-coordinates
*/

#include <algorithm> // std::sort
#include <iterator> // std::iterator_traits

namespace sort {

  template<typename I>
  I solve(I first, I past) {
    using P = typename std::iterator_traits<I>::value_type;
    std::sort(first, past,
      [](P const& p, P const& q) {
        return p.x < q.x;
      });
    return past;
  }
}