#include <cassert> // assert macro
#include <iostream> // std streams
#include "plane_sweep.h++" // plane_sweep::solve
#include "point.h++" // point
#include <vector> // std::vector

int main() {
  using P = point<int>;
  using S = std::vector<P>;
  using I = typename S::iterator;

  S bag{P(0,0), P(0,1), P(0,2), P(0,1)};
  I rest = plane_sweep::solve(bag.begin(), bag.end());
  auto h = rest - bag.begin();
  assert(h == 2);
  for (I i = bag.begin(); i != rest; ++i) {
    std::cout << *i << " ";
  }
  std::cout << "\n";
}
